# Replace Image in Template

Easily replace images in templates for personalized video creation

In this guide, we will learn how to replace **images** within a template and generate a video.

### Image Properties:

* **url:** URL of the image content.
* **asset\_id:** Asset ID of the image content.

<Callout icon="📘" theme="info">
  *url* and *asset\_id* can be retrieved from the [Upload Asset](https://movio-api.readme.io/reference/upload-asset) endpoint.
</Callout>

# Creating Template through the Interface

To create a new template:

1. Go to the HeyGen Dashboard and open the [Templates](https://app.heygen.com/templates) tab.
2. Click **Create Template**. This opens the template editor.
3. Click the **Media** tab and select an existing image or upload a new one.
4. Use the **API** icon in the toolbar to assign an **API variable** to the image.

<Image align="center" border={false} src="https://files.readme.io/a271874379e990db27d2b6ec0d2e2593e3f60fc897d27664ea688d4b11ee4da0-image_api_variable-modified.png" />

As you can see, we have assigned a variable name, i.e., `poolside_image` to our image element. In this tutorial, we will demonstrate how to change this image using the Template API.

# Get a List of Your Templates

For instructions on listing your templates that you have created in the HeyGen interface and retrieving the `template_id`, see [Get a List of Templates](https://movio-api.readme.io/docs/generate-video-from-template-v3#get-a-list-of-your-templates).

# Retrieve Template Elements

To retrieve template elements you will need to submit an API request as follows. In the response, you’ll receive details of all variables defined in the template, in this case, the image element details, which can later be modified when creating videos.

```bash Request
curl --request GET \
     --url https://api.heygen.com/v3/template/template_id \
     --header 'accept: application/json' \
     --header 'x-api-key: <your-api-key>'
```

```json Response
{
  "error": null,
  "data": {
    "version": "4",
    "variables": {
      "poolside_image": {
        "name": "poolside_image",
        "type": "image",
        "properties": {
          "url": "<url>",
          "asset_id": null,
          "fit": "contain"
        }
      }
    },
    "scenes": [
      {
        "id": "<scene_id>",
        "script": "",
        "variables": {
          "poolside_image": {
            "name": "poolside_image",
            "type": "image"
        }
      }
    ]
  }
}

```

For a full list of parameters and complete response details, see detailed API Reference: [Retrieve Template Details (V3)](https://movio-api.readme.io/reference/get-template-v3).

# Modify Template Elements and Generate Video

To change template elements and generate videos, you will need to submit an API request as follows. In the request body, *specify the elements you want to modify* by providing the appropriate object within the *variables* section.

```bash Request
curl --location 'https://api.heygen.com/v2/template/<template_id>/generate' \
     --header 'X-Api-Key: <your-api-key>' \
     --header 'Content-Type: application/json' \
     --data '{
  "caption": false,
  "title": "New Video",
  "variables": {
    "poolside_image": {
      "name": "poolside_image",
      "type": "image",
      "properties": {
        "url": "https://files.heygencdn.com/prod/movio/preset/image/origin/556f811b701548e588c7504906cd571c.jpg",
        "asset_id": null
      }
    }
  }
}'
```

```json Response
{
  "error": null,
  "data": {
    "video_id": "<video_id>"
  }
}
```

If you want to explore all configurable options - including how to update multiple elements or adjust video metadata, see detailed API Reference: [Generate Video from Template](https://movio-api.readme.io/reference/generate-from-template-v3).

You will receive a `video_id` after your request. To check the video's status and retrieve further details, you can use the [Retrieve Video Status/Details](https://movio-api.readme.io/reference/video-status) API endpoint. You can view complete status response examples on the right-side **Response** panel of the API Reference page - open the **Examples** dropdown to view responses for different video statuses. You can select any example to preview the corresponding response body.

### Status Descriptions

**`pending`**\
The video is queued and waiting to start rendering.

**`waiting`**\
The video is in waiting state.

**`processing`**\
The video is currently rendering.

**`completed`**\
The video has successfully rendered and is ready for download.

**`failed`**\
The video could not be rendered due to an error (for example, if the duration exceeds plan limits).

And using the Template API, we changed our image and generated our new video.

**Before:**

<Image border={false} src="https://files.readme.io/3cdd086f9d5052112d79ef49c531584b1d9bb47538b951a1d8c81c3b5df854af-image.png" />

**After:**

<Image border={false} src="https://files.readme.io/9c07278743de1629e6da1c179d9f11eb6e755707e2191fb1cace887c0d014d0c-image.png" />

# Conclusion

In this guide, we've walked you through the process of *replacing images* within a template video using **HeyGen's Template API**. By following the steps outlined here, you can modify image elements to create customized videos that suit your specific needs.